# vim: set sw=4 ts=4 et:
#
# spec file for package mixxx
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright (c) 2010-2012 Pascal Bleser <pascal.bleser@opensuse.org>
# Copyright (c) 2005-2010 oc2pus
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%if 0%{?suse_version} > 1320
%define use_qt5 1
%endif
Name:           mixxx
Version:        2.0.0+git20160111.2121
Release:        2.2
Summary:        Everything you need to perform live DJ mixes
License:        GPL-2.0+
Group:          Productivity/Multimedia/Sound/Players
Url:            http://www.mixxx.org
Source0:        mixxx.tar.xz
Source1000:     mixxx-rpmlintrc
Patch0:         mixxx.gcc6.patch
BuildRequires:  audiofile
BuildRequires:  fdupes
BuildRequires:  freeglut-devel
BuildRequires:  gperftools-devel
BuildRequires:  ladspa
BuildRequires:  libfaad-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libmp4v2-devel
BuildRequires:  libusb-devel
BuildRequires:  pkgconfig
BuildRequires:  portmidi-devel
BuildRequires:  scons
BuildRequires:  tolua >= 5.0
BuildRequires:  update-desktop-files
BuildRequires:  util-linux
BuildRequires:  xz
BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(audiofile)
BuildRequires:  pkgconfig(flac)
BuildRequires:  pkgconfig(flac++)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gio-unix-2.0)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gmodule-2.0)
BuildRequires:  pkgconfig(gmodule-export-2.0)
BuildRequires:  pkgconfig(gmodule-no-export-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gthread-2.0)
BuildRequires:  pkgconfig(id3tag)
BuildRequires:  pkgconfig(jack) >= 0.109
BuildRequires:  pkgconfig(libchromaprint)
BuildRequires:  pkgconfig(libmusicbrainz)
BuildRequires:  pkgconfig(libusb-1.0)
BuildRequires:  pkgconfig(lua) >= 5
BuildRequires:  pkgconfig(portaudio-2.0)
BuildRequires:  pkgconfig(protobuf)
BuildRequires:  pkgconfig(protobuf-lite)
BuildRequires:  pkgconfig(python)
BuildRequires:  pkgconfig(python-2.7)
BuildRequires:  pkgconfig(python2)
BuildRequires:  pkgconfig(rubberband)
BuildRequires:  pkgconfig(samplerate)
BuildRequires:  pkgconfig(shout)
BuildRequires:  pkgconfig(sndfile)
BuildRequires:  pkgconfig(soundtouch) >= 1.3
BuildRequires:  pkgconfig(taglib)
BuildRequires:  pkgconfig(taglib_c)
BuildRequires:  pkgconfig(vamp)
BuildRequires:  pkgconfig(vamp-hostsdk)
BuildRequires:  pkgconfig(vamp-sdk)
BuildRequires:  pkgconfig(wavpack)
BuildRequires:  pkgconfig(zlib)
Requires:       vamp-qm-plugins
Recommends:     libmp3lame0
Conflicts:      otherproviders(mixxx)
Obsoletes:      %{name}-skin-hercules
Obsoletes:      %{name}-skin-outlineClose
Obsoletes:      %{name}-skin-outline
Obsoletes:      %{name}-skin-outlineMini
Obsoletes:      %{name}-skin-outlineNetbook
Obsoletes:      %{name}-skin-nCut
Obsoletes:      %{name}-skin-Collusion
Obsoletes:      %{name}-skin-traditional
Provides:       mixxx-unstable = %{version}
Obsoletes:      mixxx-unstable < %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  mad-devel
BuildRequires:  pkgconfig(libmodplug)
BuildRequires:  pkgconfig(opus)
BuildRequires:  pkgconfig(opusfile)
BuildRequires:  pkgconfig(vorbis)
BuildRequires:  pkgconfig(vorbisenc)
BuildRequires:  pkgconfig(vorbisfile)
%if 0%{?use_qt5}
BuildRequires:  libqt5-linguist
BuildRequires:  pkgconfig(Qt5Concurrent)
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Gui)
BuildRequires:  pkgconfig(Qt5Network)
BuildRequires:  pkgconfig(Qt5OpenGL)
BuildRequires:  pkgconfig(Qt5Script)
BuildRequires:  pkgconfig(Qt5ScriptTools)
BuildRequires:  pkgconfig(Qt5Sql)
BuildRequires:  pkgconfig(Qt5Svg)
BuildRequires:  pkgconfig(Qt5Test)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5Xml)
BuildRequires:  pkgconfig(Qt5XmlPatterns)
%else
BuildRequires:  pkgconfig(Qt3Support) >= 4.8
BuildRequires:  pkgconfig(QtCLucene) >= 4.8
BuildRequires:  pkgconfig(QtCore) >= 4.8
BuildRequires:  pkgconfig(QtDBus) >= 4.8
BuildRequires:  pkgconfig(QtDeclarative) >= 4.8
BuildRequires:  pkgconfig(QtDesigner) >= 4.8
BuildRequires:  pkgconfig(QtDesignerComponents) >= 4.8
BuildRequires:  pkgconfig(QtGui) >= 4.8
BuildRequires:  pkgconfig(QtHelp) >= 4.8
BuildRequires:  pkgconfig(QtMultimedia) >= 4.8
BuildRequires:  pkgconfig(QtNetwork) >= 4.8
BuildRequires:  pkgconfig(QtOpenGL) >= 4.8
BuildRequires:  pkgconfig(QtScript) >= 4.8
BuildRequires:  pkgconfig(QtScriptTools) >= 4.8
BuildRequires:  pkgconfig(QtSql) >= 4.8
BuildRequires:  pkgconfig(QtSvg) >= 4.8
BuildRequires:  pkgconfig(QtTest) >= 4.8
BuildRequires:  pkgconfig(QtUiTools) >= 4.8
BuildRequires:  pkgconfig(QtWebKit)
BuildRequires:  pkgconfig(QtXml) >= 4.8
BuildRequires:  pkgconfig(QtXmlPatterns) >= 4.8
%endif

%description
Mixxx is free DJ software that gives you everything you need to perform live DJ mixes. Blend songs together with automatic BPM matching and remix on-the-fly with looping and hot cues. Whether you're a pro DJ or just getting started, Mixxx has you covered.

Mixxx works with ALSA, JACK, OSS and supports many popular DJ controllers.

KEY FEATURES
- Parallel or split scratchable waveform displays.
- MP3, OGG, WAVE, FLAC, and optional AAC (M4A) playback.
- WAVE, OGG, and optional MP3 recording.
- Fast, database-powered library.
- Crates and playlists for organizing your music.
- Reads iTunes, Traktor, and Rhythmbox libraries.
- Cross-platform - works on Windows, Mac OS X and Linux.
- Shoutcast and Icecast broadcasting.
- Support for many DJ MIDI and HID controllers out-of-the-box.
- Advanced MIDI scripting engine for maximum flexibility.
- Vinyl emulation with Serato, Traktor, and Mixvibes timecode support.
- Beat and key detection.
- ReplayGain volume normalization.
- Automatic crossfading with Auto DJ.
- Skinnable interface with several skins bundled.
- For a full list of features go to: http://mixxx.org/features

%prep
%setup -q -n mixxx
%patch0 -p1

%build
scons %{?_smp_mflags} \
    prefix="%{_prefix}" \
    optimize=9 \
    vinylcontrol=1 \
%if 0%{?use_qt5}
    qt5=1 \
%endif
    ffmpeg=0 \
    flac=1 \
    m4a=1 \
    mad=1 \
    modplug=1 \
    ogg=1 \
    opus=1 \
    sndfile=1 \
    faad=1 \
    shoutcast=1 \
    ipod=0 \
    hss1394=0 \
    hid=1 \
    bulk=1 \
    vamp=1 \
    wv=1 \
    asmlib=1 \
    qdebug=0 \
    verbose=0 \
    buildtime=0 \
    localecompare=0 \
    qt_sqlite_plugin=1 \
    perftools=1

%install
install -dm 755 %{buildroot}%{_bindir}

scons \
    prefix="%{_prefix}" \
    install_root="%{buildroot}%{_prefix}" \
%if 0%{?use_qt5}
    qt5=1 \
%endif
    install

rm -rf "%{buildroot}%{_datadir}/doc/mixxx"

# remove .orig files, not permitted
find "%{buildroot}%{_datadir}/mixxx/skins/" -type f -name '*.orig' -delete

# fix perms
find "%{buildroot}%{_datadir}/mixxx/" -type f -executable \( -name '*.xml' -o -name '*.js' -o -name '*.txt' \) \
-exec chmod 0644 {} \;

L="$PWD/%{name}.lang"
echo -n > "$L"
pushd "%{buildroot}%{_datadir}/mixxx/translations"
/bin/ls -1 mixxx_*.qm | while read f; do
    [ -e "$f" ] || continue
    l="${f#mixxx_}"
    l="${l%.qm}"
    echo "%lang($l) %{_datadir}/mixxx/translations/$f" >> "$L"
done
popd

# hardlinks are required to speedup build
%fdupes "%{buildroot}%{_datadir}/mixxx/skins"

%files -f %{name}.lang
%defattr(-,root,root)
%doc COPYING LICENSE Mixxx-Manual.pdf README*
%{_bindir}/mixxx
%{_libexecdir}/mixxx
%{_datadir}/mixxx
%{_datadir}/applications/mixxx.desktop
%{_datadir}/pixmaps/mixxx-icon.png
%dir %{_datadir}/appdata
%{_datadir}/appdata/mixxx.appdata.xml

%changelog
* Wed Sep 30 2015 johannesobermayr@gmx.de
- update to 1.12 branch
- remove obsolete (all) patches
* Thu Jan  9 2014 diego.ercolani@gmail.com
- adapted to build of 1.11.0
- removed support of midi due to lack of porttime under portmidi
  library distribution
  - > we need to compile libporttime and porttime.h
* Sun Jun 17 2012 pascal.bleser@opensuse.org
- add requires for libqt4-sql-sqlite
* Sat May 19 2012 seife+obs@b1-systems.com
- fix build with gcc 4.7 (missing unistd.h include)
* Sun Mar 18 2012 pascal.bleser@opensuse.org
- backport the following patches from mixxx-unstable:
  * mixxx-add_toggleValue.patch: add patch for additional key mapping
    functions: _toggle, _minus_toggle, _zero, _one, _minus_one
  * mixxx-libmp3lame_path.patch: fixes the lookup path for libmp3lame.so.0
    which is needed for streaming MP3 to Shoutcast/Icecast
- build with maximum optimization, enables SSE/SSE2/MMX
* Sun Jan  1 2012 pascal.bleser@opensuse.org
- don't use our optflags but, instead, use the optimization flags from
  upstream; that also fixes building on 12.1 where GCC crashed on assembler
  stuff; dropped mixxx-optflags.patch
* Tue Dec 27 2011 pascal.bleser@opensuse.org
- update to 1.10.0
* Fri Mar  4 2011 reddwarf@opensuse.org
- Add patch to fix mp4v2 availability check
* Wed Jan  6 2010 toni@links2linux.de
- update to 1.7.2
- reenabled m4a support
- This bugfix release addresses a number of issues that were discovered
  in 1.7.1, and is a recommended upgrade for all users
  Some of the changes include:
  Improved saving of ordered playlists
  Fixed MIDI support on OS X
  Optimize latency settings. This should improve compatibility with certain soundcards/APIs.
  Improved stability and error handling when loading certain songs.
* Sun Oct 25 2009 toni@links2linux.de
- update to 1.7.1
- This release incorporates many major improvements, hugely improved MIDI
  controller support, better vinyl control support, savable cue points, and many
  performance improvements and bugfixes.
- disabled cmetrics and m4a (won't compile)
* Sat Oct  4 2008 toni@links2linux.de
- update to 1.6.1
- removed skin sub-package (skin-Natt)
* Fri Aug  8 2008 toni@links2linux.de
- update to 1.6.0
- enabled shoutcast and iPod support
* Sat Jul 19 2008 toni@links2linux.de
- update to 1.6.0beta4
- added new skin sub-package (skin-Natt)
* Sat May 31 2008 toni@links2linux.de
- update to 1.6.0beta3
* Sun Feb 10 2008 toni@links2linux.de
- update to 1.6.0beta2
* Sat Sep  8 2007 toni@links2linux.de
- openSUSE-10.3 build, corrected BuildRequires
* Wed Mar  7 2007 toni@links2linux.de
- added -lusb in build.definition (is NOT using pkg-config!)
* Sun Mar  4 2007 toni@links2linux.de
- update to 1.5.0.1
- replaced portaudio18 with portaudio
- added libdjconsole support
* Tue Jan  2 2007 toni@links2linux.de
- build SuSE-10.2, corrected BuildRequires
* Thu Nov 30 2006 toni@links2linux.de
- update to 1.5.0beta2
- added debug_package
* Fri Sep 29 2006 toni@links2linux.de
- update to 1.5.0 (cvs 29.09.2006)
- adjusted BuildRequires
* Sun Sep 17 2006 toni@links2linux.de
- build for packman
* Thu Sep  7 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060907
- update to 1.5.0 (cvs 07.09.2006)
* Thu Aug 24 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060824
- update to 1.5.0 (cvs 24.08.2006)
* Mon Aug 14 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060814
- update to 1.5.0 (cvs 14.08.2006)
* Thu Aug 10 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060810
- update to 1.5.0 (cvs 10.08.2006)
* Wed May 31 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060531
- update to 1.5.0 (cvs 31.05.2006)
* Sat May 20 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060520
- update to 1.5.0 (cvs 20.05.2006)
* Sun Apr 23 2006 oc2pus@arcor.de 1.5.0beta1-0.oc2pus.1
- update to 1.5.0beta1
- patched to use package soundtouch=1.3
- patched to use package portaudio18
- repacked without soundtouch and portaudio18* sources
- sub-packages for skins (hercules, outlineClose, outline, traditional)
  - changed menu-entry
* Wed Mar 29 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060329
- update to 1.5.0 (cvs 29.03.2006)
* Fri Feb 24 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060224
- update to 1.5.0 (cvs 24.02.2006)
- added --enable-python
* Sat Jan 28 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060128
- update to 1.5.0 (cvs 28.01.2006)
- patched to use package soundtouch=1.3
- patched to use package portaudio18
- sub-packages for skins (hercules, outlineClose, outline, traditional)
* Tue Jan  3 2006 oc2pus@arcor.de 1.4.2-0.oc2pus.1
- initial release of rpm
- repacked as tar.bz2
